import { DescribeOptions, Engine, EngineRunResults, RuleDescription, RunOptions } from "@salesforce/code-analyzer-engine-api";
import { PmdEngineConfig } from "./config";
export declare class PmdEngine extends Engine {
    private readonly pmdWrapperInvoker;
    private readonly config;
    private readonly extensionToLanguageMap;
    private workspaceLiaisonCache;
    private pmdRuleInfoListCache;
    constructor(config: PmdEngineConfig);
    getName(): string;
    getEngineVersion(): Promise<string>;
    describeRules(describeOptions: DescribeOptions): Promise<RuleDescription[]>;
    runRules(ruleNames: string[], runOptions: RunOptions): Promise<EngineRunResults>;
    private getPmdRuleInfoList;
    private getWorkspaceLiaison;
    private toViolation;
}
